import { Http,Util } from '@/utils';
import EntityService from '../entity-service';



/**
 * 用户角色关系服务对象基类
 *
 * @export
 * @class SYS_USER_ROLEServiceBase
 * @extends {EntityServie}
 */
export default class SYS_USER_ROLEServiceBase extends EntityService {

    /**
     * Creates an instance of  SYS_USER_ROLEServiceBase.
     * 
     * @param {*} [opts={}]
     * @memberof  SYS_USER_ROLEServiceBase
     */
    constructor(opts: any = {}) {
        super(opts);
    }

    /**
     * 初始化基础数据
     *
     * @memberof SYS_USER_ROLEServiceBase
     */
    public initBasicData(){
        this.APPLYDEKEY ='sys_user_role';
        this.APPDEKEY = 'userroleid';
        this.APPDENAME = 'sys_user_roles';
        this.APPDETEXT = 'userrolename';
    }

// 实体接口

    /**
     * Select接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof SYS_USER_ROLEServiceBase
     */
    public async Select(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.sys_user && context.sys_user_role){
            return Http.getInstance().get(`/sys_users/${context.sys_user}/sys_user_roles/${context.sys_user_role}/select`,isloading);
        }
        if(context.sys_role && context.sys_user_role){
            return Http.getInstance().get(`/sys_roles/${context.sys_role}/sys_user_roles/${context.sys_user_role}/select`,isloading);
        }
            return Http.getInstance().get(`/sys_user_roles/${context.sys_user_role}/select`,isloading);
    }

    /**
     * FetchDefault接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof SYS_USER_ROLEServiceBase
     */
    public async FetchDefault(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.sys_user && true){
            let tempData:any = JSON.parse(JSON.stringify(data));
            return Http.getInstance().get(`/sys_users/${context.sys_user}/sys_user_roles/select`,tempData,isloading);
        }
        if(context.sys_role && true){
            let tempData:any = JSON.parse(JSON.stringify(data));
            return Http.getInstance().get(`/sys_roles/${context.sys_role}/sys_user_roles/select`,tempData,isloading);
        }
        let tempData:any = JSON.parse(JSON.stringify(data));
        return Http.getInstance().get(`/sys_user_roles/select`,tempData,isloading);
    }
}